# YAMLLM Documentation

YAMLLM is a Python library for YAML-based LLM configuration and execution.

## Quick Links

- [Installation Guide](installation.md)
- [Configuration Guide](configuration.md)
- [API Reference](api/index.md)
- [Examples](examples.md)
- [Contributing](contributing.md)

## Overview

YAMLLM provides a flexible framework for configuring and executing Language Model (LLM) interactions using YAML configuration files. It supports multiple LLM providers including OpenAI, Google, DeepSeek, and MistralAI.

## Features

- YAML-based configuration
- Simple API interface
- Customizable prompt templates
- Error handling and retry logic
- Built-in memory management using SQLite
- Vector database for long-term memory using semantic search
- Support for both streaming and non-streaming responses

## License

MIT License - see [LICENSE](https://github.com/codehalwell/yamllm/blob/main/LICENSE) for details.